using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace BlendSample
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        SpriteFont font;
        Texture2D background;
        Texture2D alphaImage;
        Texture2D red;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
            font = Content.Load<SpriteFont>("font");
            alphaImage = Content.Load<Texture2D>("alphasprite");

            background = new Texture2D(GraphicsDevice, 1, 1);
            background.SetData<Color>(new Color[] { Color.CornflowerBlue });

            red = new Texture2D(GraphicsDevice, 1, 1);
            red.SetData<Color>(new Color[] { Color.Red });
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();
            spriteBatch.Draw(background, GraphicsDevice.Viewport.Bounds, Color.White);
            spriteBatch.End();

            int i = 0;
            BlendState currentBlend = new BlendState();
            currentBlend.ColorBlendFunction = BlendFunction.Add;
            currentBlend.ColorSourceBlend = Blend.One;
            currentBlend.ColorDestinationBlend = Blend.One;
            DrawBlendedImage(currentBlend, "One", red, GetPoint(i++), GetSize());
            currentBlend = new BlendState();
            currentBlend.ColorBlendFunction = BlendFunction.Subtract;
            currentBlend.ColorSourceBlend = Blend.One;
            currentBlend.ColorDestinationBlend = Blend.One;
            DrawBlendedImage(currentBlend, "SubOne", red, GetPoint(i++), GetSize());
            currentBlend = new BlendState();
            currentBlend.ColorBlendFunction = BlendFunction.ReverseSubtract;
            currentBlend.ColorSourceBlend = Blend.One;
            currentBlend.ColorDestinationBlend = Blend.One;
            DrawBlendedImage(currentBlend, "RSubOne", red, GetPoint(i++), GetSize());
            currentBlend = new BlendState();
            currentBlend.ColorBlendFunction = BlendFunction.Max;
            currentBlend.ColorSourceBlend = Blend.One;
            currentBlend.ColorDestinationBlend = Blend.One;
            DrawBlendedImage(currentBlend, "Max", red, GetPoint(i++), GetSize());
            currentBlend = new BlendState();
            currentBlend.ColorBlendFunction = BlendFunction.Min;
            currentBlend.ColorSourceBlend = Blend.One;
            currentBlend.ColorDestinationBlend = Blend.One;
            DrawBlendedImage(currentBlend, "Min", red, GetPoint(i++), GetSize());
            currentBlend = new BlendState();
            currentBlend.ColorBlendFunction = BlendFunction.Add;
            currentBlend.ColorSourceBlend = Blend.SourceColor;
            currentBlend.ColorDestinationBlend = Blend.Zero;
            DrawBlendedImage(currentBlend, "2xSrc", red, GetPoint(i++), GetSize());
            currentBlend = new BlendState();
            currentBlend.ColorBlendFunction = BlendFunction.Add;
            currentBlend.ColorSourceBlend = Blend.Zero;
            currentBlend.ColorDestinationBlend = Blend.DestinationColor;
            DrawBlendedImage(currentBlend, "2xDest", red, GetPoint(i++), GetSize());
            currentBlend = new BlendState();
            currentBlend.ColorBlendFunction = BlendFunction.Add;
            currentBlend.ColorSourceBlend = Blend.InverseSourceColor;
            currentBlend.ColorDestinationBlend = Blend.One;
            DrawBlendedImage(currentBlend, "InvSrc", red, GetPoint(i++), GetSize());
            currentBlend = new BlendState();
            currentBlend.ColorBlendFunction = BlendFunction.Add;
            currentBlend.ColorSourceBlend = Blend.One;
            currentBlend.ColorDestinationBlend = Blend.InverseDestinationColor;
            DrawBlendedImage(currentBlend, "InvDest", red, GetPoint(i++), GetSize());
            currentBlend = new BlendState();
            currentBlend.ColorBlendFunction = BlendFunction.Add;
            currentBlend.ColorSourceBlend = Blend.DestinationColor;
            currentBlend.ColorDestinationBlend = Blend.SourceColor;
            DrawBlendedImage(currentBlend, "Swap", red, GetPoint(i++), GetSize());
            currentBlend = new BlendState();
            currentBlend.ColorBlendFunction = BlendFunction.Add;
            currentBlend.ColorSourceBlend = Blend.InverseDestinationColor;
            currentBlend.ColorDestinationBlend = Blend.InverseSourceColor;
            DrawBlendedImage(currentBlend, "InvSwap", red, GetPoint(i++), GetSize());
            currentBlend = new BlendState();
            currentBlend.ColorBlendFunction = BlendFunction.Add;
            currentBlend.ColorSourceBlend = Blend.One;
            currentBlend.ColorDestinationBlend = Blend.BlendFactor;
            currentBlend.BlendFactor = Color.Blue;
            DrawBlendedImage(currentBlend, "Factor", red, GetPoint(i++), GetSize());
            
            DrawBlendedImage(BlendState.AlphaBlend, "Alpha", alphaImage, GetPoint(i++), GetSize());
            DrawBlendedImage(BlendState.NonPremultiplied, "NPAlpha", alphaImage, GetPoint(i++), GetSize());

            base.Draw(gameTime);
        }

        const int size = 80;
        Point GetPoint(int i)
        {
            return new Point(10 + ((i % 9) * (size + 6)), 10 + ( (i/9) * (size * 2 + 50) ) );
        }
        Point GetSize()
        {
            return new Point(size, size);
        }
        private void DrawBlendedImage(BlendState blend, string text, 
            Texture2D image, Point position, Point size)
        {
            // Draw the source image on top opaque
            spriteBatch.Begin(SpriteSortMode.Deferred, BlendState.Opaque);
            spriteBatch.Draw(image, new Rectangle(position.X, position.Y, 
                size.X, size.Y), Color.White);
            spriteBatch.End();

            Vector2 measure = font.MeasureString(text);
            spriteBatch.Begin();
            spriteBatch.DrawString(font, text, new Vector2(position.X, 
                position.Y + size.Y + 2), Color.White);
            spriteBatch.End();

            // Draw the blended version now
            spriteBatch.Begin(SpriteSortMode.Deferred, blend);
            spriteBatch.Draw(image, new Rectangle(position.X, 
                position.Y + size.Y + (int)measure.Y + 2,
                size.X, size.Y), Color.White);
            spriteBatch.End();
        }
    }
}
