﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Content;

namespace CustomAvatarAnimation
{
    // The animation data that is processed by the content pipeline
    public class CustomAvatarAnimationData
    {
        // The name of the animation
        [ContentSerializer]
        public string Name { get; private set; }

        // The total length the animation plays
        [ContentSerializer]
        public TimeSpan Length { get; private set; }

        // All of the keyframes that make up the animation
        [ContentSerializer]
        public List<Keyframe> Keyframes { get; private set; }

        // Parameterless constructor needed by the XNB deserializer 
        private CustomAvatarAnimationData() { }

        public CustomAvatarAnimationData(string name, TimeSpan length, List<Keyframe> keyframes)
        {
            Name = name;
            Length = length;
            Keyframes = keyframes;
        }
    }
}
