using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace GuideSample
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        GamePadState lastState;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            Components.Add(new GamerServicesComponent(this));

            base.Initialize();
            Guide.IsScreenSaverEnabled = false;
            Guide.SimulateTrialMode = true;
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here
            GamePadState state = GamePad.GetState(PlayerIndex.One);

            if (!Guide.IsVisible)
            {
                if (WasButtonPressed(Buttons.A, state, lastState))
                {
                    Guide.ShowFriends(PlayerIndex.One);
                }
                if (WasButtonPressed(Buttons.X, state, lastState))
                {
                    Guide.ShowPlayers(PlayerIndex.One);
                }
                if (WasButtonPressed(Buttons.B, state, lastState))
                {
                    Guide.ShowParty(PlayerIndex.One);
                }
                if (WasButtonPressed(Buttons.Y, state, lastState))
                {
                    Guide.ShowMessages(PlayerIndex.One);
                }
                if (WasButtonPressed(Buttons.LeftShoulder, state, lastState))
                {
                    Guide.ShowSignIn(4, false);
                }

            }

            lastState = state;
            base.Update(gameTime);
        }

        /// <summary>
        /// Simple helper to determine if a button was pressed
        /// </summary>
        public bool WasButtonPressed(Buttons button, GamePadState current, GamePadState last)
        {
            return (current.IsButtonUp(button) && last.IsButtonDown(button));
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Guide.IsVisible ? Color.Black : Color.CornflowerBlue);

            // TODO: Add your drawing code here

            base.Draw(gameTime);
        }

    }
}
